Imports System
Imports System.Collections.Generic
Imports System.Text

Public Enum Hl7State
    NEED_TO_POLL_APP
    WAITING_FOR_ACK
End Enum

Public Class ClientState
    Public MessageId As String
    Public Message As String
    Public AckEta As DateTime
    Public CurrentState As Hl7State
    Private random As New Random

    Private Function MakeMessageId() As String
        Dim CurrentTime As DateTime
        CurrentTime = System.DateTime.Now
        Return CurrentTime.Hour.ToString() + CurrentTime.Minute.ToString() + CurrentTime.Second.ToString() + CurrentTime.Millisecond.ToString()
    End Function

    Public Function FetchMessage() As Boolean
        If (random.Next(2) <> 1) Then
            ' We only have a message one time in 2
            Return False
        End If
        MessageId = MakeMessageId()
        Message = "MSH|^~\\&|MESA_ADT|XYZ_ADMITTING|MESA_IS|XYZ_HOSPITAL|" + MessageId + "||ADT^A04|" + MessageId + "|P|2.3.1||||||||" + Constants.vbCr
        Message += "EVN||200004211000||||200004210950" + Constants.vbCr
        Message += "PID|||583020^^^ADT1||REYNOLDS^MALCOLM||19710321|M||AI|SERENITY^^FIREFLY CLASS CARGO SHIP|||||||20-98-1701||||||||||||" + Constants.vbCr
        Return True
    End Function

    Public Sub ConfirmMessageSend()
        ' TODO - a real application would mark the current message as sent in it's database.
        CurrentState = Hl7State.NEED_TO_POLL_APP
    End Sub

    Public Sub SetAckTimeOut(ByVal timeoutInSeconds As Integer)
        AckEta = DateTime.Now
        AckEta.AddSeconds(timeoutInSeconds)
        CurrentState = Hl7State.WAITING_FOR_ACK
    End Sub

    Public Function IsTimedOut() As Boolean
        Return (DateTime.Now > AckEta)
    End Function
End Class

        
